//*****************************************************************************
//*
//*
//*		LightCalculatorDlg.cpp : Implementierungsdatei
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//
#include	"StdAfx.h"
#include	"LightCalculator.h"
#include	"LightCalculatorDlg.h"
#include	"AfxUtility.h"
#include	"AfxDialog.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
char		 THIS_FILE[] = __FILE__;
#endif

#define 	VAR_COUNT		22						// Anzahl der Variabeln
#define 	FOM_COUNT		9						// Anzahl der Formeln
#define 	NONE		   -123.456
#define		PI				3.1415926535897932384626433832795
#define		START_VAR		VAR_LICHTSTAERKE
#define		FILE_SUFIX		"lcalc"
#define 	IDC_UPDATE		200
#define 	XX				222

#define 	VAR_LICHTSTAERKE		0				// [CD]
#define 	VAR_LICHTSTROM			1				// [LM]
#define 	VAR_BELEUCHTUNGSST		2				// [LUX]
#define 	VAR_ABSTRAHLWINKEL		3				// []
#define 	VAR_RAUMWINKEL			4				// [SR]
#define 	VAR_FLAECHE				5				// [M]
#define 	VAR_HOEHE				6				// [M]
#define 	VAR_DURCHMESSER			7				// [M]
#define 	VAR_LEISTUNG			8				// [W]
#define 	VAR_LICHTAUSBEUTE		9				// [W/LM]
#define 	VAR_RAUMGROESE			10				// [m]
#define 	VAR_STUNDENPROTAG		11				// [h]
#define 	VAR_BETREIBSTAGE		12				// [Tage]
#define 	VAR_STUNDENPROJAHR		13				// [h]
#define 	VAR_BELEUCHTUNGRAUM		14				// [lux]
#define 	VAR_LAMPENZAHL			15				// [#]
#define 	VAR_LEBENSDAUER			16				// [m]
#define 	VAR_LAMPENPREIS			17				// [Euro]
#define 	VAR_STROMPREIS			18				// [Euro]
#define 	VAR_BETRIEBSKOSTEN		19				// [Euro]
#define 	VAR_LAMPENWIRKGRAD		20				// [%]
#define 	VAR_RAUMWIRKGRAD		21				// [%]


BYTE		aStartSelect[]=							// Welche Variablen sollen als Vorgabe gewhlt werden
			{
			VAR_LICHTSTROM			,
			VAR_ABSTRAHLWINKEL		,
			VAR_HOEHE				,
			VAR_LEISTUNG			,
			VAR_RAUMGROESE			,
			VAR_STUNDENPROTAG		,
			VAR_BETREIBSTAGE		,
			VAR_BELEUCHTUNGRAUM		,
			VAR_LEBENSDAUER			,
			VAR_LAMPENPREIS			,
			VAR_STROMPREIS			,
			VAR_LAMPENWIRKGRAD		,
			VAR_RAUMWIRKGRAD		,
			};



unsigned	aIds[] =								// ID's der Fenster fr die Variabeln
			{
			IDC_EDIT0		,IDC_CHECK0		,IDB_NOPICTURE	,
			IDC_EDIT1		,IDC_CHECK1		,IDB_NOPICTURE	,
			IDC_EDIT2		,IDC_CHECK2		,IDB_NOPICTURE	,
			IDC_EDIT3		,IDC_CHECK3		,IDB_BITMAP1	,
			IDC_EDIT4		,IDC_CHECK4		,IDB_BITMAP2	,
			IDC_EDIT5		,IDC_CHECK5		,IDB_BITMAP3	,
			IDC_EDIT6		,IDC_CHECK6		,IDB_BITMAP4	,
			IDC_EDIT7		,IDC_CHECK7		,IDB_BITMAP5	,
			IDC_EDIT8		,IDC_CHECK8		,IDB_NOPICTURE	,
			IDC_EDIT9		,IDC_CHECK9		,IDB_NOPICTURE	,
			IDC_EDIT10		,IDC_CHECK10	,IDB_BITMAP6	,
			IDC_EDIT11		,IDC_CHECK11	,IDB_NOPICTURE	,
			IDC_EDIT12		,IDC_CHECK12	,IDB_NOPICTURE	,
			IDC_EDIT13		,IDC_CHECK13	,IDB_NOPICTURE	,
			IDC_EDIT14		,IDC_CHECK14	,IDB_NOPICTURE	,
			IDC_EDIT15		,IDC_CHECK15	,IDB_NOPICTURE	,
			IDC_EDIT16		,IDC_CHECK16	,IDB_NOPICTURE	,
			IDC_EDIT17		,IDC_CHECK17	,IDB_NOPICTURE	,
			IDC_EDIT18		,IDC_CHECK18	,IDB_NOPICTURE	,
			IDC_EDIT19		,IDC_CHECK19	,IDB_NOPICTURE	,
			IDC_EDIT20		,IDC_CHECK20	,IDB_BITMAP8	,
			IDC_EDIT21		,IDC_CHECK21	,IDB_BITMAP7	,
			};


//	Formel mit einer hhern Prioritt werden zuerst berechnet.
//	Variabeln mit einer hhern Prioritt werden eher als Vorgabe benutzt
//	Variabeln mit XX sind nur Eingangsvariablen und werden nicht berechnet

BYTE		aDependency[(VAR_COUNT+1)*FOM_COUNT] =
							{	//  A	B	C	D	E	F   G   H   J
/*-------------------------------------------------------------------*/
/*  -  Formelprioritt          */	7,	5,	8,	6,	4,	7,	2,	3,	3,
/*-------------------------------------------------------------------*/
/*  0  Lichtstrke         cd   */	0,	0,	8,	0,	0,	0,	0,	0,	0,
/*  1  Lichtstrom          lm   */	0,	0,	9,	0,	9,	5,	0,	3,	0,
/*  2  Beleuchtungsstrke  lux  */	0,	0,	0,	0,	1,	0,	0,	0,	0,
/*  3  Abstrahlwinkel          */	5,	9,	0,	0,	0,	0,	0,	0,	0,
/*  4  Raumwinkel          sr   */	0,	5,	5,	0,	0,	0,	0,	0,	0,
/*  5  Beleuchtungsflche  m   */	0,	0,	0,	5,	5,	0,	0,	0,	0,
/*  6  Lampenhhe          m    */	9,	0,	0,	0,	0,	0,	0,	0,	0,
/*  7  Durchmesser         m    */	1,	0,	0,	9,	0,	0,	0,	0,	0,
/*  8  Elekt. Leistung     W    */	0,	0,	0,	0,	0,	9,	0,	0,	6,
/*  9  Lichtausbeute       lm/W */	0,	0,	0,	0,	0,	1,	0,	0,	0,
/* 10  Raumgre           m   */	0,	0,	0,	0,	0,	0,	0,	7,	0,
/* 11  Betriebstunden/Tag  h    */	0,	0,	0,	0,	0,	0,	9,	0,	0,
/* 12  Betriebtage/Jahr    Tage */	0,	0,	0,	0,	0,	0,	8,	0,	0,
/* 13  Betriebstunden/Jahr h    */	0,	0,	0,	0,	0,	0,	7,	0,	2,
/* 14  Beleuchtungsst.Raum lux  */	0,	0,	0,	0,	0,	0,	0,	6,	0,
/* 15  Lampenanzahl        #    */	0,	0,	0,	0,	0,	0,	0,	1,	3,
/* 16  Lebensdauer         h    */	0,	0,	0,	0,	0,	0,	0,	0,	9,
/* 17  Preis je Lampe      Euro */	0,	0,	0,	0,	0,	0,	0,	0,	7,
/* 18  Strompreis          Euro */	0,	0,	0,	0,	0,	0,	0,	0,	8,
/* 19  Betriebskosten/Jahr Euro */	0,	0,	0,	0,	0,	0,	0,	0,	1,
/* 20  Lampenwirkungsgrad  %    */	0,	0,	0,	0,	0,	0,	0,	8,	0,
/* 21  Raumwirkungsgrad    %    */	0,	0,	0,	0,	0,	0,	0,	9,	0,
							};

double		aInitVal[VAR_COUNT] =
			{
/*  0  Lichtstke          cd   */	0.0,
/*  1  Lichtstrom          lm   */	1000.0,
/*  2  Beleuchtungsstrke  lux  */	500.0,
/*  3  Abstrahlwinkel          */	36.0,
/*  4  Raumwinkel          sr   */	0.0,
/*  5  Beleuchtungsflche  m   */	0.0,
/*  6  Lampenhhe          m    */	2.5,
/*  7  Durchmesser         m    */	0.0,
/*  8  Elekt. Leistung     W    */	20.0,
/*  9  Lichtausbeute       W/lm */	0.0,
/* 10  Raumgre           m   */	20.0,
/* 11  Betriebstunden/Tag  h    */	5.0,
/* 12  Betriebtage/Jahr    Tage */	300.0,
/* 13  Betriebstunden/Jahr h    */	0.0,
/* 14  Beleuchtungsst.Raum lux  */	500.0,
/* 15  Lampenanzahl        #    */	0.0,
/* 16  Lebensdauer         m    */	2000.0,
/* 17  Preis je Lampe      Euro */	2.0,
/* 18  Strompreis          Euro */	0.19,
/* 19  Betriebskosten/Jahr Euro */	0.0,
/* 20  Lampenwirkungsgrad  %    */  80.0,
/* 21  Raumwirkungsgrad    %    */  70.0,
			};




char *aVarNames[VAR_COUNT*2] =
	{
    "Lichtstke          >cd  ",	"Ist die durchschnittliche Helligkeit einer Lichtquelle im Abstand von einem Meter zu Lichtquelle. \n\nLichtstke =  Lichtstrom / Raumwinkel\n\n",
    "Lichtstrom          >lm  ",	"Ist die gesammte Lichtmenge die von einer Lichtquelle abgegeben wird.\n\nLichtstrom = Lichtstke * Raumwinkel",
    "Beleuchtungsstrke  >lux ",	"Ist die Helligkeit die der Lichtkegel der Lichquelle am Boden erzeugt. Mit steigender Hhe der Lichtquelle sinkt die Beleuchtungsstrke zum Quartrat.",
    "Abstrahlwinkel      >   ",	"Ist der Winkel mit dem das Licht von der Lichtquelle abgestrahlt wird.",
    "Raumwinkel          >sr  ",	"Ist die Flche des Lichtkegels die auf die Eingeitskugel (d=1m) strahlt. Der Raumwinkel ist abhngig vom Abstrahlwinkel:\n\nRaumwinkel = 2*PI * [ 1-cos(Abstrahlwinkel/2) ]",
    "Beleuchtungsflche  >m  ",	"Ist die Flache die der Lichtkegel einer Lichtquelle ausleuchet.Flche = Durchmesser * PI / 4\n\n",
    "Lampenhhe          >m   ",	"Ist die Hhe in der die Lichtquelle montiert ist.",
    "Durchmesser         >m   ",	"Ist der Durchmesser der Flche die von einer Lichtquelle ausgeleuchtet wird.Durchmesser = 2 * Lampenhhe * tan(Abstrahlwinkel/2)",
    "Elekt. Leistung     >W   ",	"Ist die elektische Leistung in Watt der Lichtquelle.",
    "Lichtausbeute       >W/lm",	"Ist die Menge an Licht die pro Watt elektischer Leistung von der Lichtquelle abgegeben wird.\n\nLichtausbeute = Lichtstrom / Leistung",
    "Raumgre           >m  ",	"Ist die Gre des Raumes der ausgeleuchet werden soll.",
    "Betriebstunden/Tag  >h   ",	"Ist die duchschnittliche Zeit die das Licht im Raum pro Tag eingeschalten ist.",
    "Betriebtage/Jahr    >Tage",	"Ist die Anzahl der Tage an denen das Licht pro Jahr eingeschalten ist.",
    "Betriebstunden/Jahr >h   ",	"Ist die Zeit die das Licht im Raum pro Jahr eingeschalten ist.",
    "Beleuchtungsst.Raum >lux ",	"Ist die Helligkeit die im Raum herschen soll.\n\n200 lux = Wohnzimmer\n500 lux = Arbeitsrume",
    "Lampenanzahl        >#   ",	"Ist die Anzahl der Lampe die im Raumbentigt werden um die gewnschte Helligkeit zu erreichen",
    "Lebensdauer         >m   ",	"Ist die Zeit in Stunden die eine Lampe im Schnitt als Lebensdauer hat.",
    "Preis je Lampe      >Euro",	"Ist der Preis eine einzigen Lampe.",
    "Strompreis          >Euro",	"Ist der Preis fr eine Kilowattstunde Strom.",
    "Betriebskosten/Jahr >Euro",	"Sind die errechneten Betreibskosten fr alle Lampen pro Jahr.",
    "Lampenwirkungsgrad  >%   ",	"Ist der Wirkungsgrad der Lampe. Er gibt an wieviel Prozen des Lichtes die Lampe verlsst.\n\nDieser Wert kann aus dem Datenblatt der Lampe entnommen werden.",
    "Raumwirkungsgrad    >%   ",	"Besimmt wieviel Prozent des Lichtes von den Wnden, Boden und Decke zum Auge reflektiert wird.\n\n   k = a*b / /h*(a+b))\n\nMit k kann der Raumwirkungsgrad aus einer Tabelle entnommen werden. Dazu werden die Reflexionsgrade von Decke, Boden und Wnden bentig.",
	};



double		aMinMaxComa[VAR_COUNT*3] =					// Bestimmt den Bereich in demeine Variable erlaubt ist
							{	//  Comma	Min		Max
/*  0  Lichtstke          cd   */	0,		0.0,	NONE,
/*  1  Lichtstrom          lm   */	1,		0.0,	NONE,
/*  2  Beleuchtungsstrke  lux  */	0,		0.0,	NONE,
/*  3  Abstrahlwinkel          */	1,		1.0,	120.0,
/*  4  Raumwinkel          sr   */	3,		0.0,	2.0*PI,
/*  5  Beleuchtungsflche  m   */	2,		0.0,	NONE,
/*  6  Lampenhhe          m    */	2,		0.1,	20.0,
/*  7  Durchmesser         m    */	2,		0.0,	NONE,
/*  8  Elekt. Leistung     W    */	2,		0.0,	NONE,
/*  9  Lichtausbeute       W/lm */	2,		0.0,	NONE,
/* 10  Raumgre           m   */	2,		0.0,	NONE,
/* 11  Betriebstunden/Tag  h    */	1,		0.0,	24.0,
/* 12  Betriebtage/Jahr    Tage */	0,		0.0,	365.0,
/* 13  Betriebstunden/Jahr h    */	1,		1.0,	365.0*24.0,
/* 14  Beleuchtungsst.Raum lux  */	0,		0.0,	NONE,
/* 15  Lampenanzahl        #    */	1,		0.0,	NONE,
/* 16  Lebensdauer         m    */	0,		0.0,	NONE,
/* 17  Preis je Lampe      Euro */	2,		0.0,	NONE,
/* 18  Strompreis          Euro */	2,		0.0,	NONE,
/* 19  Betriebskosten/Jahr Euro */	2,		0.0,	NONE,
/* 20  Lampenwirkungsgrad  %    */	0,		1.0,	100.0,
/* 21  Raumwirkungsgrad    %    */	0,		1.0,	100.0,
							};

unsigned	aVarCount  [FOM_COUNT];					// Anzahl der Variabeln je Formel
BYTE		uFormPrior [FOM_COUNT];					// Formeln nach Prioritten sortiert
BYTE		aFormPerVar[VAR_COUNT*FOM_COUNT];		// Formel   = uVarsPerForm[iVar *VAR_COUNT+i] bis 255 (priorisiert angeordned)
BYTE		aVarPerForm[VAR_COUNT*FOM_COUNT];		// Variabel = uVarsPerForm[iForm*FOR_COUNT+i] bis 255 (priorisiert angeordned)
HBITMAP		aBitmap	   [VAR_COUNT+1];				// Handels auf die Variabel Bilder
unsigned	aFormCount [VAR_COUNT];					// Anzahl der Formeln je Variabeln
double		aValues    [VAR_COUNT];					// Werte der einzelnen Variabeln
unsigned	aCalced    [VAR_COUNT];					// Wird die Variabel berechnet
unsigned	aFixed     [VAR_COUNT];					// Ist die Variabel vor dem ndern geschtzt
unsigned	aClick     [VAR_COUNT];					// Ist die Nummer mit der eine Variable geklickt wurde
unsigned	uClickNr=0;								// Aktuelle Klicknummer



BEGIN_MESSAGE_MAP(CLightCalculatorDlg, CDialog)
	//{{AFX_MSG_MAP(CLightCalculatorDlg)
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_WM_CTLCOLOR()
	ON_WM_SYSCOMMAND()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_LOAD, OnLoad)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_DATABASE, OnDatabase)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

#define 	COLOR_DIS	RGB(220,220,255)
#define 	COLOR_OUT	RGB(255,220,220)
#define 	COLOR_DEF	RGB(255,255,200)

HBRUSH		hBrushDis;
HBRUSH		hBrushOut;
HBRUSH		hBrushDef;

#define 	ID_COLS		(sizeof(aIds)/sizeof(aIds[0])/VAR_COUNT)
#define 	ID_COUNT	(sizeof(aIds)/sizeof(aIds[0]))
#define		TOPI(w)		((w)*PI/180.0)
#define		TOGR(w)		((w)*180.0/PI)
#define 	FORM(v,p)	aFormPerVar[(v)*FOM_COUNT+(p)]
#define 	VAR(f,p)	aVarPerForm[(f)*VAR_COUNT+(p)]
#define 	DEP(f,v)	aDependency[(v)*FOM_COUNT+FOM_COUNT+(f)]

//*****************************************************************************
//*
//*		IdToVar
//*
//*****************************************************************************
//	Sucht die Variabelnummer zu einer Fenster-ID
//	uId		: Ist die ID nach der gesucht wird
//	uSub	: Ist die Spalte im ID Feld in der gesucht werden soll
//	Ergibt die Variabelnummer bzw. -1 wenn nicht gefunden wurde
inline int IdToVar(unsigned uId,unsigned uSub=0)
{
int			iVar;


	if(uSub>=ID_COLS)return -1;

	for(iVar=uSub;iVar<ID_COUNT;iVar+=ID_COLS)
		{
		if(aIds[iVar]==uId)return iVar/ID_COLS;
		}



return -1;
}

//*****************************************************************************
//*
//*		CLightCalculatorDlg Dialogfeld
//*
//*****************************************************************************
CLightCalculatorDlg::CLightCalculatorDlg(CWnd *pParent):CDialog(CLightCalculatorDlg::IDD,pParent)
{
char		aSet[VAR_COUNT];
int			iForm;
UINT		uPos;
int			iVar;
int			iTow;
int			i;


	memset(aVarPerForm,255,sizeof(aVarPerForm));
	memset(aFormPerVar,255,sizeof(aFormPerVar));

	//{{AFX_DATA_INIT(CLightCalculatorDlg)
	//}}AFX_DATA_INIT

	m_hIcon			= AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_uBmbNumber	= 0xFFFFFFFF;
	m_uPictureId	= 0;

	memset(aValues,0,sizeof(aValues));

	for(i=0;i<VAR_COUNT;i++)
		{
		aValues[i] = aInitVal[i];
		}


	for(iForm=0;iForm<FOM_COUNT;iForm++)					// Zhle Variabelanzahl in den Formeln
		{
		aVarCount[iForm] = 0;

		for(iVar=0;iVar<VAR_COUNT;iVar++)
			{
			if(DEP(iForm,iVar)==0)continue;
			VAR(iForm,aVarCount[iForm])=iVar;
			aSet[aVarCount[iForm]]=iVar;
			aVarCount[iForm]++;
			}


		for(uPos=1;uPos<aVarCount[iForm];uPos++)			// Feld nach PruPosoruPostten sortuPoseren
			{
			iVar=VAR(iForm,uPos-1);
			iTow=VAR(iForm,uPos  );

			if(DEP(iForm,iVar)>=DEP(iForm,iTow))continue;

			VAR(iForm,uPos-1)=iTow;
			VAR(iForm,uPos  )=iVar;

			uPos=0;
			}


		if(aVarCount[iForm]==2)								// Direktabhngigkeiten  berechnen
			{
			iVar=aSet[0];
			i   =aSet[1];

			if(aValues[iVar]!=0.0 && aValues[i]==0.0)iVar=aSet[1];
			else if( DEP(iForm,i) < DEP(iForm,iVar) )iVar=aSet[1];

			Calc(iForm,iVar);
			}
		}


	for(iVar=0;iVar<VAR_COUNT;iVar++)						// Zhle Formelanzahl in fr die Variabeln
		{
		aFormCount[iVar] = 0;

		for(iForm=0;iForm<FOM_COUNT;iForm++)
			{
			if(DEP(iForm,iVar)==0)continue;
			FORM(iVar,aFormCount[iVar])=iForm;
			aFormCount[iVar]++;
			}


		for(uPos=1;uPos<aFormCount[iVar];uPos++)			// Feld nach PruPosoruPostten sortuPoseren
			{
			iForm=FORM(iVar,uPos-1);
			iTow =FORM(iVar,uPos  );

			if(DEP(iForm,iVar)>=DEP(iTow,iVar))continue;

			FORM(iVar,uPos-1)=iTow;
			FORM(iVar,uPos  )=iForm;

			uPos=0;
			}
		}


	for(iForm=0;iForm<FOM_COUNT;iForm++)					// Array mit Formel nach Prioritten sortieren
		{
		uFormPrior[iForm]=iForm;
		}

	for(uPos=1;uPos<FOM_COUNT;uPos++)
		{
		iForm=uFormPrior[uPos-1];
		iTow =uFormPrior[uPos  ];

		if(aDependency[iForm]<=aDependency[iTow])continue;

		uFormPrior[uPos-1] = iTow;
		uFormPrior[uPos  ] = iForm;

		uPos = 0;
		}

	for(iVar=0;iVar<VAR_COUNT;iVar++)						// Bilder Handels laden
		{
		aBitmap[iVar] = LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(aIds[iVar*ID_COLS+2]));
		}

	aBitmap[iVar] = LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_NOPICTURE));

}

//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CLightCalculatorDlg::DoDataExchange(CDataExchange *pDX)
{
CWnd	   *pWnd;
int			iVar;
unsigned	uId;


	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CLightCalculatorDlg)
	DDX_Control(pDX, IDC_PICTURE, m_cPicture);
	//}}AFX_DATA_MAP

	pWnd = GetFocus();
	uId  = (pWnd)? GetWndId(pWnd):0;


	for(iVar=0;iVar<VAR_COUNT;iVar++)
		{
		if(uId!=aIds[iVar*ID_COLS+0] || pDX->m_bSaveAndValidate)DDX_Float(pDX,aIds[iVar*ID_COLS+0],aValues[iVar],(unsigned)aMinMaxComa[iVar*3]);
		}

}



//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CLightCalculatorDlg::OnInitDialog()
{
CMenu      *pSysMenu;
int			iVar;
int			i;


	hBrushDis = CreateSolidBrush(COLOR_DIS);
	hBrushOut = CreateSolidBrush(COLOR_OUT);
	hBrushDef = CreateSolidBrush(COLOR_DEF);



	CDialog::OnInitDialog();

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT( IDM_ABOUTBOX < 0xF000);

	   pSysMenu = GetSystemMenu(FALSE);
	if(pSysMenu != NULL)
		{
		CString sAboutMenu;

			sAboutMenu.LoadString(IDS_ABOUTBOX);
		if(!sAboutMenu.IsEmpty())
			{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, sAboutMenu);
			}
		}

	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden




	for(i=0;i<sizeof(aStartSelect)/sizeof(aStartSelect[0]);i++)
		{
		OnCheck(aStartSelect[i]);
		}


	for(iVar=0;iVar<VAR_COUNT;iVar++)
		{
		if(aCalced[iVar])continue;
		OnChangeEdit(iVar);
		}


	SetTimer(IDC_UPDATE,250,NULL);



return TRUE;
}


//*****************************************************************************
//*
//*		OnSysCommand
//*
//*****************************************************************************
void CLightCalculatorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if((nID&0xFFF0) == IDM_ABOUTBOX)
		{
		CDialog dlgAbout(IDD_ABOUTBOX);
		dlgAbout.DoModal();
		}
	else{
		CDialog::OnSysCommand(nID, lParam);
		}
}


//*****************************************************************************
//*
//*		OnPaint
//*
//*****************************************************************************
//  Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.
void CLightCalculatorDlg::OnPaint()
{
int		iIconX;
int		iIconY;
int		iPosX;
int		iPosY;
CRect	sRect;



	if(IsIconic())
		{
		CPaintDC sDc(this);						// Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) sDc.GetSafeHdc(), 0);


		iIconX = GetSystemMetrics(SM_CXICON);	// Symbol in Client-Rechteck zentrieren
		iIconY = GetSystemMetrics(SM_CYICON);

		GetClientRect(&sRect);

		iPosX = (sRect.Width ()-iIconX+1)/2;
		iPosY = (sRect.Height()-iIconY+1)/2;

		
		sDc.DrawIcon(iPosX,iPosY,m_hIcon);		// Symbol zeichnen
		}
	else{
		CDialog::OnPaint();
		}
}


//*****************************************************************************
//*
//*		OnQueryDragIcon
//*
//*****************************************************************************
HCURSOR CLightCalculatorDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


//*****************************************************************************
//*
//*		OnCtlColor
//*
//*****************************************************************************
HBRUSH CLightCalculatorDlg::OnCtlColor(CDC *pDC,CWnd *pWnd,UINT nCtlColor)
{
HBRUSH		hBrush;
int			iVar;
unsigned 	uId;



	hBrush  = CDialog::OnCtlColor(pDC,pWnd,nCtlColor);
	uId		= GetWindowLong(pWnd->m_hWnd,GWL_ID);
	iVar    = IdToVar(uId);

	if(iVar>=0)
		{
		pDC->SetBkColor((aCalced[iVar])? COLOR_DIS:COLOR_DEF);
		return (aCalced[iVar])? hBrushDis:hBrushDef;
		}


return hBrush;
}

//*****************************************************************************
//*
//*		OnCmdMsg
//*
//*****************************************************************************
BOOL CLightCalculatorDlg::OnCmdMsg(UINT nID, int nCode, void *pExtra, AFX_CMDHANDLERINFO *pHandlerInfo)
{
CWnd   *pWnd;
int		iVar;
int		iVal;


	switch(nCode)
		{
	case EN_CHANGE:		   iVar = IdToVar(nID);
						if(iVar>=0){OnChangeEdit(iVar);return 1;}
						break;

	case EN_KILLFOCUS:	   iVar = IdToVar(nID);
						if(aCalced[iVar])return 1;
						if(iVar>=0){OnChangeEdit(iVar);return 1;}
						break;

	case BN_CLICKED:	if(nID==IDOK)
							{
							   pWnd = GetFocus();
							if(pWnd)
								{
								iVal = GetWndId(pWnd);
								if(IdToVar(iVal,0))return 1;
								if(IdToVar(iVal,1))return 1;
								}
							}

						   iVar = IdToVar(nID,1);
						if(iVar>=0){OnCheck(iVar);return 1;}
						break;
		}



return CDialog::OnCmdMsg(nID,nCode,pExtra,pHandlerInfo);
}


//*****************************************************************************
//*
//*		OnCheck?
//*
//*****************************************************************************
//	iVar	: Ist die Variabelnummer die gedrckt wurde.
void CLightCalculatorDlg::OnCheck(int iVar)
{
int			i,iForm,iNone,iFormular;
int			iErrors,iFound;
int			iMin,iNext,iTurn;
char		aErr [VAR_COUNT];
char		aSet [VAR_COUNT];
char		aNext[VAR_COUNT];
char		aDone[FOM_COUNT];
unsigned 	uClickVal;
unsigned	uCount;
unsigned	uPos;
unsigned	uNum;



	UpdateData();


	memset(aSet   ,0,sizeof(aSet   ));
	memset(aDone  ,0,sizeof(aDone  ));

	uClickNr++;
	aClick[iVar] = uClickNr;
	aFixed[iVar] = !aFixed[iVar];
	aSet  [iVar] = 1;
	aNext [0]    = iVar;
	iNext		 = 1;




	for(;;)														// Prfe fixierte Variabeln
		{
		iErrors = 0;
		memset(aSet,0,sizeof(aSet));

		for(iForm=0;iForm<FOM_COUNT;iForm++)
			{
			uCount      = 0;
			iMin		= VAR(iForm,0);
			uClickVal	= 0xFFFFFFFF;

			for(uPos=0;uPos<aVarCount[iForm];uPos++)			// Zhle Vorgaben
				{
				iVar = VAR(iForm,uPos);

				if(aFixed[iVar] || DEP(iForm,iVar)==XX)
					{
					uCount++;
					}

				if(uClickVal>aClick[iVar])
					{
					iMin      = iVar;
					uClickVal = aClick[iVar];
					}
				}
																// Zuviele Vorgaben
			if(aVarCount[iForm]>0 && uCount>=aVarCount[iForm] && aSet[iMin]==0)		
				{
				aErr[iErrors ] = iMin;
				aSet[iMin    ] = 1;
				iErrors++;
				}
			}

		if(iErrors==0)break;

		iMin		= aErr[0];
		uClickVal	= 0xFFFFFFFF;

		for(i=0;i<iErrors;i++)									// Suche ltesten Fehler
			{
			iVar = aErr[i];

			if(uClickNr>aClick[iVar])
				{
				iMin      = iVar;
				uClickVal = aClick[iVar];
				}
			}

		aFixed[iMin] = 0;
		}



	memset(aCalced,0,sizeof(aCalced));

	for(iFormular=0;iFormular<FOM_COUNT;iFormular++)			// Suche zuberechen Felder setzen
		{
		uCount = 0;

		for(uPos=0;uPos<aVarCount[iFormular];uPos++)			// Zhle Vorgaben
			{
			iVar = VAR(iFormular,uPos);

			if(aFixed[iVar] || aCalced[iVar] || DEP(iFormular,iVar)==XX)
				{							
				uCount++;
				}
			else{
				iNone=iVar;
				}
			}

		if(uCount+1!=aVarCount[iFormular])continue;				// Nur ein freier Platz

		memset(aDone,0,sizeof(aDone));
		memset(aNext,0,sizeof(aNext));
		memset(aSet ,0,sizeof(aSet ));

		aNext  [0]	       = iNone;
		aDone  [iFormular] = 1;
		aSet   [iNone]     = 1;
		aCalced[iNone]     = 1;
		iErrors            = 0;
		iNext		       = 1;

		for(iTurn=0;iTurn<iNext;iTurn++)						// Prfe die Variabel rekursiv
			{
			iVar = aNext[iTurn];

			for(uNum=0;uNum<aFormCount[iVar];uNum++)
				{
				iForm = FORM(iVar,uNum);
				if(aDone[iForm])continue;

				iFound		= 0;
				uCount		= 0;
				iMin		= VAR(iForm,0);
				uClickVal	= 0xFFFFFFF;

				for(uPos=0;uPos<aVarCount[iForm];uPos++)		// Zhle Vorgaben
					{
					i = VAR(iForm,uPos);

					if(aFixed[i] || aCalced[i] || DEP(iForm,1)==XX)
						{
						uCount++;
						}
					else{
						iFound++;
						iNone=i;
						}
					}

				if(iFound==0)									// Fehler gefunden
					{
					for(uPos=0;uPos<aVarCount[iForm];uPos++)
						{
						i = VAR(iForm,uPos);

						if(aSet[i])continue;
						aSet[i      ]=1;
						aErr[iErrors]=i;
						iErrors++;
						}

					aDone[iForm] = 1;
					}

				if(iFound==1)									// Weiter Berechnungswert
					{
					aCalced[iNone] = 1;
					if(aSet[iNone]==0)
						{
						aSet [iNone]=1;
						aNext[iNext]=iNone;
						iNext++;
						}

					aDone[iForm] = 1;
					}
				}
			}

		if(iErrors)												// Wurden Fehler gefunden
			{
			iMin		= aErr[0];
			uClickVal	= 0xFFFFFFF;

			for(i=0;i<iErrors;i++)								// Suche ltesten Fehler
				{
				iVar = aErr[i];

				if(uClickVal>aClick[iVar])
					{
					iMin      = iVar;
					uClickVal = aClick[iVar];
					}
				}

			memset(aCalced,0,sizeof(aCalced));
			aFixed[iMin] =  0;
			iFormular    = -1;
			}
		}





	for(iVar=0;iVar<VAR_COUNT;iVar++)
		{
		GetDlgButton(aIds[iVar*ID_COLS+1])->SetCheck   ((aFixed [iVar])? 1:0);
		GetDlgEdit  (aIds[iVar*ID_COLS+0])->SetReadOnly((aCalced[iVar])? 1:0);
		}

}





//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CLightCalculatorDlg::OnTimer(UINT_PTR nIDEvent)
{
CWnd	   *pWnd;
unsigned	uVar;
unsigned	uId;


	if(nIDEvent!=IDC_UPDATE)
		{
		CDialog::OnTimer(nIDEvent);
		return;
		}


		pWnd = GetFocus();
	if(!pWnd)return;

	uId = GetWindowLong(pWnd->m_hWnd,GWL_ID);

	if(m_uPictureId==uId)return;


	for(uVar=0;uVar<VAR_COUNT;uVar++)					// Suche das Focus Fenster
		{
		if(aIds[uVar*ID_COLS+0]!=uId)
		if(aIds[uVar*ID_COLS+1]!=uId)continue;

		break;
		}

	if(uVar!=m_uBmbNumber)
		{
		m_uBmbNumber = uVar;
		m_cPicture.SetBitmap(aBitmap[uVar]);
		}


	SetDlgItemText(IDC_TEXT,(uVar<VAR_COUNT)? aVarNames[uVar*2+1]:"");
	m_uPictureId = uId;


}

//*****************************************************************************
//*
//*		OnChangeEdit?
//*
//*****************************************************************************
//	iVar	: Ist die Variabelnummer die gendert wurde.
void CLightCalculatorDlg::OnChangeEdit(int iVar)
{
double		aLast[VAR_COUNT];
char		aSet [VAR_COUNT];
char		aNext[VAR_COUNT];
char		aDone[FOM_COUNT];
int			i,iNum,iForm,iNext;
int			iMax,iFormMax;
int			iTurn,iNone;
unsigned	uPos,uNum;
unsigned	uIgnore;
unsigned	uCount;
unsigned	uPrior;



	UpdateData();


	if(aMinMaxComa[iVar*3+1]!=NONE)								// Ist ein Minimum definiert
		{
		if(aValues[iVar]<aMinMaxComa[iVar*3+1])aValues[iVar]=aMinMaxComa[iVar*3+1];
		}

	if(aMinMaxComa[iVar*3+2]!=NONE)								// Ist ein Maximum definiert
		{
		if(aValues[iVar]>aMinMaxComa[iVar*3+2])aValues[iVar]=aMinMaxComa[iVar*3+2];
		}


	memcpy(aLast,aValues,sizeof(aLast));
	memset(aDone,0,sizeof(aDone));
	memset(aSet ,0,sizeof(aSet ));

	aSet[iVar] = 1;
	aNext[0]   = iVar;
	iNext      = 1;
	iNum       = 0;

	for(iTurn=0;;)
		{
		for(iForm=0;iForm<FOM_COUNT;iForm++)					// Direkte Abhngikeiten
			{
			uCount  = 0;
			uIgnore	= 0;

			for(uNum=0;uNum<aVarCount[iForm];uNum++)
				{
				i = VAR(iForm,uNum);

				if(aFixed[i])continue;
				if(aSet  [i])continue;
				
				if(DEP(iForm,i)==XX)							// Ist immer eine Eingangsvariable
					{
					uIgnore++;
					continue;
					}

				uCount++;
				iNone=i;
				}

			if(uCount==1 && uIgnore==0)							// Eine Formel mit einer Abhngigkeit gefunden
				{
				Calc(iForm,iNone);
				aDone[iForm] = 2;

				if(!aSet[iNone])								// Hat sich der Wert verndert
					{
					aSet[iNone] = 1;

					if(aLast[iNone]!=aValues[iNone])
						{
						aNext[iNext] = iNone;
						iNext++;
						}
					}
				}
			}

		iVar = aNext[iTurn];

		for(uPos=0;uPos<aFormCount[iVar];uPos++)				// Suche alle Formeln zur Variabel
			{
			iForm = FORM(iVar,uPos);
			if(aDone[iForm]==2)continue;

			uCount  = 0;
			uIgnore = 0;

			for(uNum=0;uNum<aVarCount[iForm];uNum++)
				{
				i = VAR(iForm,uNum);

				if(aFixed[i])continue;
				if(aSet  [i])continue;

				if(DEP(iForm,i)==XX)							// Ist immer eine Eingangsvariable
					{
					uIgnore++;
					continue;
					}

				uCount++;
				iNone=i;
				}

			if(uCount==0 && uIgnore==0)							// Eine Formel ohne einer Abhngigkeit gefunden
				{
				aDone[iForm]=2;
				}

			if(uCount==1 && uIgnore==0)							// Eine Formel mit einer Abhngigkeit gefunden
				{
				Calc(iForm,iNone);
				aDone[iForm] = 2;

				if(!aSet[iNone])								// Hat sich der Wert verndert
					{
					aSet[iNone] = 1;

					if(aLast[iNone]!=aValues[iNone])
						{
						aNext[iNext] = iNone;
						iNext++;
						}
					}
				}

			if(uCount+uIgnore>=2)								// Eine Formel mit mehreren Abhngigkeit gefunden
				{
				aDone[iForm]=1;
				}
			}

		iTurn++;

		if(iTurn<iNext)continue;								// Gibt es weitere Variabeln

		iMax	 =  0;
		iFormMax = -1;

		for(iForm=0;iForm<FOM_COUNT;iForm++)					// Welche Formel hat die hchste Prioritt
			{
			if(aDone      [iForm]!=  1)continue;
			if(aDependency[iForm]<iMax)continue;

			iMax		= aDependency[iForm];
			iFormMax	= iForm;
			}

		if(iFormMax==-1)break;

		iForm   = iFormMax;
		iVar    = -1;
		iMax    = 256;
		uPrior	= 256;
		uCount  = 0;
		uIgnore = 0;

		for(uNum=aVarCount[iForm];uNum>0;)						// Suche unfixierte Variabel mit niedrigster Prioritt
			{
			uNum--;

			i = VAR(iForm,uNum);

			if(aFixed[i])continue;
			if(aSet  [i])continue;

			   uPos = DEP(iForm,i);
			if(uPos==XX)										// Ist immer eine Eingangsvariable
				{
				uIgnore++;
				continue;
				}
			
			if(uPos<uPrior)
				{
				iVar	= i;
				uPrior	= uPos;
				}
			}

		aDone[iForm]=2;

		if(iVar>=0)
			{
			Calc(iForm,iVar);

			if(aSet[iVar]==0)
				{
				aSet   [iVar ]=1;
				aNext  [iNext]=iVar;
				iNext++;
				}
			}

		iTurn--;
		}


	UpdateData(FALSE);
}


//*****************************************************************************
//*
//*		OnLoad
//*
//*****************************************************************************
void CLightCalculatorDlg::OnLoad()
{
int			aSet[VAR_COUNT];
int			aFix[VAR_COUNT];
double		aVal[VAR_COUNT];
char		cBuffer[256];
char		cTag   [256];
FILE	   *pFile;
CString		sPath;
int			iLine;
int			iVar;
int			iNum;
int			iPos;



	sPath=m_sFilePath;
	if(sPath=="")sPath="*."FILE_SUFIX;

	CFileDialog	sFile(TRUE,"*."FILE_SUFIX,sPath,OFN_EXPLORER|OFN_ENABLESIZING|OFN_HIDEREADONLY,"Datendatei ( *."FILE_SUFIX" )|*."FILE_SUFIX"|Alle Dateien|*.*|");

	   sFile.m_ofn.lpstrTitle="Daten laden";
	if(sFile.DoModal()!=IDOK)return;

	m_sFilePath=sFile.GetPathName();					// Pfad speichern


		pFile = fopen(m_sFilePath,"rb");
	if(!pFile)
		{
		MessageBox("Die Datei wurde nicht gefunden !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	memset(aFix,0,sizeof(aFix));
	memset(aSet,0,sizeof(aSet));

	iLine = 0;
	iNum  = 0;

	while(fgets(cBuffer,sizeof(cBuffer),pFile))
		{
		   iLine++;
		if(iLine>1000)break;

		cBuffer[sizeof(cBuffer)-1]=0;


		for(iVar=0;iVar<VAR_COUNT;iVar++)
			{
			strlcpy(cTag,aVarNames[iVar*2],sizeof(cTag));
			iPos = strchar(cTag,'>');
			cTag[iPos]=0;
			strcut(cTag);

			iPos = strfind(cBuffer,cTag);
			if(iPos>=0)break;
			}

		if(iVar>=VAR_COUNT)continue;

		iPos += strlen(cTag);
		iPos += strchar(cBuffer+iPos,'=');

		if(cBuffer[iPos]!='=')continue;

		iPos++;
		iNum++;
		
		aSet[iVar]=1;
		aVal[iVar]=atof(cBuffer+iPos);

		iPos += strchar(cBuffer+iPos,'*');
		if(cBuffer[iPos]=='*')aFix[iVar]=1;
		}

	fclose(pFile);

	if(iNum<=0)
		{
		MessageBox("Die Datei hat das falsche Format !","Fehler",MB_OK|MB_ICONERROR);
		}


	for(iVar=0;iVar<VAR_COUNT;iVar++)
		{
		aValues[iVar] = aVal[iVar];
		if(!aFix[iVar] && aFixed[iVar])OnCheck(iVar);
		}

	for(iVar=0;iVar<VAR_COUNT;iVar++)
		{
		if(!aSet[iVar])continue;
		aValues[iVar] = aVal[iVar];
		if(aFix[iVar] && !aFixed[iVar])OnCheck(iVar);
		}

	for(iVar=0;iVar<VAR_COUNT;iVar++)
		{
		if(!aSet[iVar])continue;
		aValues[iVar] = aVal[iVar];
		if(!aFix[iVar] && aFixed[iVar])OnCheck(iVar);
		}

	for(iVar=0;iVar<VAR_COUNT;iVar++)
		{
		if(!aSet[iVar])continue;
		aValues[iVar] = aVal[iVar];
		if(aFix[iVar] && !aFixed[iVar])OnCheck(iVar);
		}

	UpdateData(FALSE);

	for(iVar=0;iVar<VAR_COUNT;iVar++)
		{
		if(!aSet  [iVar])continue;
		if(aCalced[iVar])continue;
		aValues[iVar] = aVal[iVar];
		if(!aFix[iVar])OnChangeEdit(iVar);
		}

	for(iVar=0;iVar<VAR_COUNT;iVar++)
		{
		if(!aSet  [iVar])continue;
		aValues[iVar] = aVal[iVar];
		if(aFix[iVar])OnChangeEdit(iVar);
		}

	UpdateData(FALSE);

}


//*****************************************************************************
//*
//*		OnSave
//*
//*****************************************************************************
void CLightCalculatorDlg::OnSave()
{
char		cBuffer[256];
FILE	   *pFile;
CString		sPath;
int			iVar;
int			iPos;


	sPath=m_sFilePath;
	if(sPath=="")sPath="*."FILE_SUFIX;

	CFileDialog	sFile(FALSE,"*."FILE_SUFIX,sPath,OFN_EXPLORER|OFN_ENABLESIZING|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,"Datendatei ( *."FILE_SUFIX" )|*."FILE_SUFIX"|Alle Dateien|*.*|");

	   sFile.m_ofn.lpstrTitle="Daten speichern";
	if(sFile.DoModal()!=IDOK)return;

	m_sFilePath=sFile.GetPathName();					// Pfad speichern


	if(ExistFile(m_sFilePath)==1)
		{
		if(MessageBox("Die Datei existiert bereits !\nSoll sie berschrieben werden ?","Fehler",MB_YESNO|MB_ICONQUESTION)!=IDYES)return;
		}

		pFile = fopen(m_sFilePath,"wb");
	if(!pFile)
		{
		MessageBox("Die Datei konnte nicht gespeichert werden !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}



	for(iVar=0;iVar<VAR_COUNT;iVar++)
		{
		strlcpy(cBuffer,aVarNames[iVar*2],sizeof(cBuffer));
		iPos = strchar(cBuffer,'>');

		if(cBuffer[iPos])
			{
			cBuffer[iPos]=0;
			iPos++;
			}

		fprintf(pFile,"%s = %18f %s",cBuffer,aValues[iVar],cBuffer+iPos);
		if(aFixed[iVar])fprintf(pFile,"  *");
		fprintf(pFile,"\n");
		}

	fclose(pFile);

}

//*****************************************************************************
//*
//*		SortDatabase
//*
//*****************************************************************************
int _cdecl CLightCalculatorDlg::SortDatabase(CStringChain *pChain,int iPos1,int iPos2)
{
return strvicmp(pChain->Get(iPos1),pChain->Get(iPos2));
}

//*****************************************************************************
//*
//*		OnDatabase
//*
//*****************************************************************************
void CLightCalculatorDlg::OnDatabase()
{
char			cBuffer[4096];
char			cName[256];
FILE		   *pFile;
LPCSTR			pText;
static CString	sLast;
CStringChain	sList;
CStringChain	sData;
CComboDlg		sDlg;
CString			sTxt;
int				iPos;
int				iLen;
int				iVar;
int				iSel;


		pFile = fopen("LightDatabase.csv","rb");
	if(!pFile)
		{
		MessageBox("Die Datei 'LightDatabase.csv' konnte nicht geffnet werden !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	cBuffer[sizeof(cBuffer)-1] = 0;

	while(fgets(cBuffer,sizeof(cBuffer)-1,pFile))
		{
		if(cBuffer[0]== 0  )continue;
		if(cBuffer[0]==';' )continue;
		if(cBuffer[0]=='\n')continue;
		if(cBuffer[0]=='\r')continue;

		sData.Add(cBuffer);
		}


	sData.Sort(0,-1,SortDatabase);

	if(sData.Count()<=0)
		{
		MessageBox("Die Datenbankdatei 'LightDatabase.csv' ist leer !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}


	for(iPos=0;iPos<sData.Count();iPos++)
		{
		pText = sData[iPos];
		iLen  = strchar(pText,';');

		strlcpy(cName,pText,sizeof(cName),iLen);
		strcut(cName);

		sDlg.InsertString(iPos,cName);

		if(sLast==cName)sDlg.SetSelect(iPos);
		}


	sDlg.SetTitle("Datenbank");
	sDlg.SetTextTitle("Lichtquelle auswhlen");

	if(sDlg.DoModal()!=IDOK)return;

	iSel  = sDlg.GetSelect();
	sLast = sDlg.GetText();
	pText = sData[iSel];
	sList.KAdd(';',pText);


	for(iVar=0;iVar<VAR_COUNT;iVar++)						// Werte setzen
		{
			pText = sList[iVar+1];
		if(!pText)
			{
			continue;
			}

			pText += strwlen(pText,0xE0);
		if(!pText[0])
			{
			continue;
			}

		if(pText[0]=='*')
			{
			if(GetDlgButton(aIds[iVar*3+1])->GetCheck()==0)continue;
			GetDlgButton(aIds[iVar*3+1])->SetCheck(0);
			OnCheck(iVar);
			}
		else{
			if(GetDlgButton(aIds[iVar*3+1])->GetCheck()!=1)
				{
				GetDlgButton(aIds[iVar*3+1])->SetCheck(1);
				OnCheck(iVar);
				}

			GetDlgButton(aIds[iVar*3+0])->SetWindowText(pText);
			OnChangeEdit(iVar);
			}
		}

}

//*****************************************************************************
//*
//*		Calc
//*
//*****************************************************************************
//	Berechnet eine Formel
//	iForm	: Ist die Nummer der Formel die berechnet werden soll
//	iVar	: Ist die Nummer der Variabel die berechnet werden soll
void CLightCalculatorDlg::Calc(int iForm,int iVar)
{

	switch(iForm)												// Variabeln berechnen
		{
	case 0:	FormelA(iVar);	break;
	case 1:	FormelB(iVar);	break;
	case 2:	FormelC(iVar);	break;
	case 3:	FormelD(iVar);	break;
	case 4:	FormelE(iVar);	break;
	case 5:	FormelF(iVar);	break;
	case 6:	FormelG(iVar);	break;
	case 7:	FormelH(iVar);	break;
	case 8:	FormelJ(iVar);	break;
		}

}

//*****************************************************************************
//*
//*		FormelA
//*
//*****************************************************************************
//	Durchmesser = 2 * Hhe * tan(Winkel/2)
//	iVar	: Ist die Variabel die berechnet werden soll
void CLightCalculatorDlg::FormelA(int iVar)
{
double		dDiv;
double		dVal;

	switch(iVar)
		{
	case VAR_ABSTRAHLWINKEL:

			   dDiv = aValues[VAR_HOEHE];
			if(dDiv<=0.00001)dDiv=0.00001;

			dVal	 = aValues[VAR_DURCHMESSER]/dDiv;
			dVal	/= 2.0;
			aValues[VAR_ABSTRAHLWINKEL]	 = atan(dVal);
			aValues[VAR_ABSTRAHLWINKEL]	 = TOGR(aValues[VAR_ABSTRAHLWINKEL])*2.0;

			break;

	case VAR_HOEHE:

			dVal				= TOPI(aValues[VAR_ABSTRAHLWINKEL])/2.0;
			dDiv				= tan(dVal);

			if(dDiv<0.00000001)dDiv=0.00000001;

			aValues[VAR_HOEHE]  = aValues[VAR_DURCHMESSER]/dDiv*0.5;

			break;

	case VAR_DURCHMESSER:

			dVal					  = TOPI(aValues[VAR_ABSTRAHLWINKEL])/2.0;
			aValues[VAR_DURCHMESSER]  = aValues[VAR_HOEHE];
			aValues[VAR_DURCHMESSER] *= 2.0;
			aValues[VAR_DURCHMESSER] *= tan(dVal);
			break;

		}

}

//*****************************************************************************
//*
//*		FormelB
//*
//*****************************************************************************
//	Raumwinkel = 2*PI*(1-cos(Winkel/2))
//	iVar	: Ist die Variabel die berechnet werden soll
void CLightCalculatorDlg::FormelB(int iVar)
{
double		dVal;


	switch(iVar)
		{
	case VAR_RAUMWINKEL:

			dVal                     = TOPI(aValues[VAR_ABSTRAHLWINKEL])/2.0;
			aValues[VAR_RAUMWINKEL]  = 1.0-cos(dVal);
			aValues[VAR_RAUMWINKEL] *= PI;
			aValues[VAR_RAUMWINKEL] *= 2.0;

			break;

	case VAR_ABSTRAHLWINKEL:

			   dVal= 1.0-aValues[VAR_RAUMWINKEL]/2.0/PI;
			if(dVal> 1.0)dVal =  1.0;
			if(dVal<-1.0)dVal = -1.0;

			aValues[VAR_ABSTRAHLWINKEL] = TOGR(acos(dVal)*2.0);
			break;

		}

}

//*****************************************************************************
//*
//*		FormelC
//*
//*****************************************************************************
//	Lichtstrom = Lichtstrke * Raumwinkel
//	iVar	: Ist die Variabel die berechnet werden soll
void CLightCalculatorDlg::FormelC(int iVar)
{
double		dDiv;


	switch(iVar)
		{
	case VAR_LICHTSTROM:

			aValues[VAR_LICHTSTROM]	 = aValues[VAR_RAUMWINKEL];
			aValues[VAR_LICHTSTROM]	*= aValues[VAR_LICHTSTAERKE];

			break;

	case VAR_RAUMWINKEL:

			dDiv			 	    = aValues[VAR_LICHTSTAERKE];

			if(dDiv<0.00000001)dDiv=0.00000001;

			aValues[VAR_RAUMWINKEL] = aValues[VAR_LICHTSTROM]/dDiv;

			break;

	case VAR_LICHTSTAERKE:

			dDiv				      = aValues[VAR_RAUMWINKEL];

			if(dDiv<0.00000001)dDiv=0.00000001;

			aValues[VAR_LICHTSTAERKE] = aValues[VAR_LICHTSTROM]/dDiv;

			break;

		}

}

//*****************************************************************************
//*
//*		FormelD
//*
//*****************************************************************************
//	Flche = Duchmesser / 4 * PI
//	iVar	: Ist die Variabel die berechnet werden soll
void CLightCalculatorDlg::FormelD(int iVar)
{
double		dVal;


	switch(iVar)
		{
	case VAR_FLAECHE:

			aValues[VAR_FLAECHE]  = aValues[VAR_DURCHMESSER];
			aValues[VAR_FLAECHE] *= aValues[VAR_DURCHMESSER];
			aValues[VAR_FLAECHE] *= PI;
			aValues[VAR_FLAECHE] /= 4.0;

			break;

	case VAR_DURCHMESSER:

			dVal  = aValues[VAR_FLAECHE];
			dVal *= 4.0;
			dVal /= PI;

			if(dVal<0.0)dVal=0.0;

			aValues[VAR_DURCHMESSER] = sqrt(dVal);
			break;

		}

}

//*****************************************************************************
//*
//*		FormelE
//*
//*****************************************************************************
//	Beleuchtungstrke = Lichtstrom / Beleuchtungsflche
//	iVar	: Ist die Variabel die berechnet werden soll
void CLightCalculatorDlg::FormelE(int iVar)
{
double		dDiv;


	switch(iVar)
		{
	case VAR_FLAECHE:

			dDiv				 = aValues[VAR_BELEUCHTUNGSST];

			if(dDiv<0.00000001)dDiv=0.00000001;

			aValues[VAR_FLAECHE] = aValues[VAR_LICHTSTROM]/dDiv;

			break;

	case VAR_BELEUCHTUNGSST:

			dDiv				 = aValues[VAR_FLAECHE];

			if(dDiv<0.00000001)dDiv=0.00000001;

			aValues[VAR_BELEUCHTUNGSST] = aValues[VAR_LICHTSTROM]/dDiv;

			break;

	case VAR_LICHTSTROM:

			aValues[VAR_LICHTSTROM]  = aValues[VAR_FLAECHE];
			aValues[VAR_LICHTSTROM] *= aValues[VAR_BELEUCHTUNGSST];

			break;

		}

}

//*****************************************************************************
//*
//*		FormelF
//*
//*****************************************************************************
//	Lichtausbeute = Liststrom / Elektr.Leistung
//	iVar	: Ist die Variabel die berechnet werden soll
void CLightCalculatorDlg::FormelF(int iVar)
{
double		dDiv;


	switch(iVar)
		{
	case VAR_LICHTSTROM:

			aValues[VAR_LICHTSTROM]	 = aValues[VAR_LEISTUNG];
			aValues[VAR_LICHTSTROM]	*= aValues[VAR_LICHTAUSBEUTE];

			break;

	case VAR_LEISTUNG:

			dDiv			 	  = aValues[VAR_LICHTAUSBEUTE];

			if(dDiv<0.00000001)dDiv=0.00000001;

			aValues[VAR_LEISTUNG] = aValues[VAR_LICHTSTROM]/dDiv;

			break;

	case VAR_LICHTAUSBEUTE:

			dDiv				      = aValues[VAR_LEISTUNG];

			if(dDiv<0.00000001)dDiv=0.00000001;

			aValues[VAR_LICHTAUSBEUTE] = aValues[VAR_LICHTSTROM]/dDiv;

			break;

		}

}

//*****************************************************************************
//*
//*		FormelG
//*
//*****************************************************************************
//	Jahresbetriebstunden = Tagesbetriebstunden*Tage
//	iVar	: Ist die Variabel die berechnet werden soll
void CLightCalculatorDlg::FormelG(int iVar)
{
double		dDiv;


	switch(iVar)
		{
	case VAR_STUNDENPROJAHR:

			aValues[VAR_STUNDENPROJAHR]	 = aValues[VAR_STUNDENPROTAG];
			aValues[VAR_STUNDENPROJAHR]	*= aValues[VAR_BETREIBSTAGE];

			break;

	case VAR_STUNDENPROTAG:

			dDiv				       = aValues[VAR_BETREIBSTAGE];

			if(dDiv<0.00000001)dDiv=0.00000001;

			aValues[VAR_STUNDENPROTAG] = aValues[VAR_STUNDENPROJAHR]/dDiv;

			break;

	case VAR_BETREIBSTAGE:

			dDiv				      = aValues[VAR_STUNDENPROTAG];

			if(dDiv<0.00000001)dDiv=0.00000001;

			aValues[VAR_BETREIBSTAGE] = aValues[VAR_STUNDENPROJAHR]/dDiv;

			break;

		}

}

//*****************************************************************************
//*
//*		FormelH
//*
//*****************************************************************************
//	Lampenzahl = (Raumflche*Bereuchtungstrkeraum)/Lichtstrom_je_Lampe/Raumwikungsgrad/Lampemwirkungsgrad
//	iVar	: Ist die Variabel die berechnet werden soll
void CLightCalculatorDlg::FormelH(int iVar)
{
double		dDiv;


	switch(iVar)
		{
	case VAR_LAMPENZAHL:

			dDiv  = aValues[VAR_LICHTSTROM];
			dDiv *= aValues[VAR_LAMPENWIRKGRAD]*0.01;
			dDiv *= aValues[VAR_RAUMWIRKGRAD  ]*0.01;

			if(dDiv<0.000000001)dDiv=0.000000001;

			aValues[VAR_LAMPENZAHL]		= aValues[VAR_RAUMGROESE];
			aValues[VAR_LAMPENZAHL]	   *= aValues[VAR_BELEUCHTUNGRAUM];
			aValues[VAR_LAMPENZAHL]	   /= dDiv;

			if(aValues[VAR_LAMPENZAHL]>100000000.0)aValues[VAR_LAMPENZAHL]=100000000.0;
			if(aValues[VAR_LAMPENZAHL]<0.0        )aValues[VAR_LAMPENZAHL]=0.0;

			break;

	case VAR_RAUMGROESE:

			dDiv  = aValues[VAR_BELEUCHTUNGRAUM];

			if(dDiv<0.000000001)dDiv=0.000000001;

			aValues[VAR_RAUMGROESE]		= aValues[VAR_LICHTSTROM];
			aValues[VAR_RAUMGROESE]	   *= aValues[VAR_LAMPENZAHL];
			aValues[VAR_RAUMGROESE]	   *= aValues[VAR_LAMPENWIRKGRAD]*0.01;
			aValues[VAR_RAUMGROESE]	   *= aValues[VAR_RAUMWIRKGRAD  ]*0.01;
			aValues[VAR_RAUMGROESE]	   /= dDiv;

			break;

	case VAR_BELEUCHTUNGRAUM:

			dDiv  = aValues[VAR_RAUMGROESE];

			if(dDiv<0.000000001)dDiv=0.000000001;

			aValues[VAR_BELEUCHTUNGRAUM]	= aValues[VAR_LICHTSTROM];
			aValues[VAR_BELEUCHTUNGRAUM]   *= aValues[VAR_LAMPENZAHL];
			aValues[VAR_BELEUCHTUNGRAUM]   *= aValues[VAR_LAMPENWIRKGRAD]*0.01;
			aValues[VAR_BELEUCHTUNGRAUM]   *= aValues[VAR_RAUMWIRKGRAD  ]*0.01;
			aValues[VAR_BELEUCHTUNGRAUM]   /= dDiv;

			break;

	case VAR_LICHTSTROM:

			dDiv  = aValues[VAR_LAMPENZAHL];
			dDiv *= aValues[VAR_LAMPENWIRKGRAD]*0.01;
			dDiv *= aValues[VAR_RAUMWIRKGRAD  ]*0.01;

			if(dDiv<0.000000001)dDiv=0.000000001;

			aValues[VAR_LICHTSTROM]		= aValues[VAR_RAUMGROESE];
			aValues[VAR_LICHTSTROM]	   *= aValues[VAR_BELEUCHTUNGRAUM];
			aValues[VAR_LICHTSTROM]	   /= dDiv;

			break;

	case VAR_RAUMWIRKGRAD:

			dDiv  = aValues[VAR_LAMPENZAHL];
			dDiv *= aValues[VAR_LICHTSTROM];
			dDiv *= aValues[VAR_LAMPENWIRKGRAD]*0.01;

			if(dDiv<0.000000001)dDiv=0.000000001;

			aValues[VAR_RAUMWIRKGRAD]		= aValues[VAR_RAUMGROESE]*100.0;
			aValues[VAR_RAUMWIRKGRAD]	   *= aValues[VAR_BELEUCHTUNGRAUM];
			aValues[VAR_RAUMWIRKGRAD]	   /= dDiv;

			break;

	case VAR_LAMPENWIRKGRAD:

			dDiv  = aValues[VAR_LAMPENZAHL];
			dDiv *= aValues[VAR_LICHTSTROM];
			dDiv *= aValues[VAR_RAUMWIRKGRAD]*0.01;

			if(dDiv<0.000000001)dDiv=0.000000001;

			aValues[VAR_LAMPENWIRKGRAD]		= aValues[VAR_RAUMGROESE]*100.0;
			aValues[VAR_LAMPENWIRKGRAD]	   *= aValues[VAR_BELEUCHTUNGRAUM];
			aValues[VAR_LAMPENWIRKGRAD]	   /= dDiv;

			break;

		}

}

//*****************************************************************************
//*
//*		FormelJ
//*
//*****************************************************************************
//	Jahresbetriebkosten = Lampenzahl*Jahresbetriebstunden*(Stromkosten*Leistung/1000+Lampenkosten/Lebendauer)
//	iVar	: Ist die Variabel die berechnet werden soll
void CLightCalculatorDlg::FormelJ(int iVar)
{
double		dDiv;
double		dVal;


	switch(iVar)
		{
	case VAR_BETRIEBSKOSTEN:

			dVal	 = aValues[VAR_STROMPREIS];
			dVal	*= aValues[VAR_LEISTUNG];
			dVal	/= 1000.0;

			dDiv	 = aValues[VAR_LEBENSDAUER];

			if(dDiv<0.000000001)dDiv=0.000000001;

			dVal	+= aValues[VAR_LAMPENPREIS]/dDiv;

			aValues[VAR_BETRIEBSKOSTEN]	 = dVal;
			aValues[VAR_BETRIEBSKOSTEN]	*= aValues[VAR_LAMPENZAHL];
			aValues[VAR_BETRIEBSKOSTEN] *= aValues[VAR_STUNDENPROJAHR];

			if(aValues[VAR_BETRIEBSKOSTEN]<0.0)aValues[VAR_BETRIEBSKOSTEN]=0.0;

			break;

	case VAR_LAMPENZAHL:

			dVal	 = aValues[VAR_STROMPREIS];
			dVal	*= aValues[VAR_LEISTUNG];
			dVal	/= 1000.0;

			dDiv	 = aValues[VAR_LEBENSDAUER];

			if(dDiv<0.000000001)dDiv=0.000000001;

			dVal	+= aValues[VAR_LAMPENPREIS]/dDiv;

			if(dVal<0.000000001)dVal=0.000000001;

			dDiv	 = aValues[VAR_STUNDENPROJAHR];

			if(dDiv<0.000000001)dDiv=0.000000001;

			aValues[VAR_LAMPENZAHL]	 = aValues[VAR_BETRIEBSKOSTEN];
			aValues[VAR_LAMPENZAHL] /= dDiv;
			aValues[VAR_LAMPENZAHL]	/= dVal;

			if(aValues[VAR_LAMPENZAHL]<0.0)aValues[VAR_LAMPENZAHL]=0.0;

			break;

	case VAR_STUNDENPROJAHR:

			dVal	 = aValues[VAR_STROMPREIS];
			dVal	*= aValues[VAR_LEISTUNG];
			dVal	/= 1000.0;

			dDiv	 = aValues[VAR_LEBENSDAUER];

			if(dDiv<0.000000001)dDiv=0.000000001;

			dVal	+= aValues[VAR_LAMPENPREIS]/dDiv;

			if(dVal<0.000000001)dVal=0.000000001;

			dDiv	 = aValues[VAR_LAMPENZAHL];

			if(dDiv<0.000000001)dDiv=0.000000001;

			aValues[VAR_STUNDENPROJAHR]	 = aValues[VAR_BETRIEBSKOSTEN];
			aValues[VAR_STUNDENPROJAHR] /= dDiv;
			aValues[VAR_STUNDENPROJAHR]	/= dVal;

			if(aValues[VAR_STUNDENPROJAHR]<0.0)aValues[VAR_STUNDENPROJAHR]=0.0;

			break;

	case VAR_LEISTUNG:

			dDiv	 = aValues[VAR_STUNDENPROJAHR];
			dDiv	*= aValues[VAR_LAMPENZAHL];

			if(dDiv<0.000000001)dDiv=0.000000001;

			dVal	 = aValues[VAR_BETRIEBSKOSTEN];
			dVal	/= dDiv;

			dDiv	 = aValues[VAR_LEBENSDAUER];

			if(dDiv<0.000000001)dDiv=0.000000001;

			dVal	-= aValues[VAR_LAMPENPREIS]/dDiv;
			dVal	*= 1000;

			dDiv	 = aValues[VAR_STROMPREIS];

			if(dDiv<0.000000001)dDiv=0.000000001;

			aValues[VAR_LEISTUNG] = dVal/dDiv;

			if(aValues[VAR_LEBENSDAUER]<0.0)aValues[VAR_LEBENSDAUER]=0.0;

			break;

	case VAR_STROMPREIS:

			dDiv	 = aValues[VAR_STUNDENPROJAHR];
			dDiv	*= aValues[VAR_LAMPENZAHL];

			if(dDiv<0.000000001)dDiv=0.000000001;

			dVal	 = aValues[VAR_BETRIEBSKOSTEN];
			dVal	/= dDiv;

			dDiv	 = aValues[VAR_LEBENSDAUER];

			if(dDiv<0.000000001)dDiv=0.000000001;

			dVal	-= aValues[VAR_LAMPENPREIS]/dDiv;
			dVal	*= 1000.0;

			dDiv	 = aValues[VAR_LEISTUNG];

			if(dDiv<0.000000001)dDiv=0.000000001;

			aValues[VAR_STROMPREIS] = dVal/dDiv;

			if(aValues[VAR_STROMPREIS]<0.0)aValues[VAR_STROMPREIS]=0.0;

			break;

	case VAR_LAMPENPREIS:

			dDiv	 = aValues[VAR_STUNDENPROJAHR];
			dDiv	*= aValues[VAR_LAMPENZAHL];

			if(dDiv<0.000000001)dDiv=0.000000001;

			dVal	 = aValues[VAR_BETRIEBSKOSTEN];
			dVal	/= dDiv;
			dVal	-= aValues[VAR_LEISTUNG]*aValues[VAR_STROMPREIS]/1000.0;

			aValues[VAR_LAMPENPREIS] = dVal*aValues[VAR_LEBENSDAUER];

			if(aValues[VAR_LAMPENPREIS]<0.0)aValues[VAR_LAMPENPREIS]=0.0;

			break;

	case VAR_LEBENSDAUER:

			dDiv	 = aValues[VAR_STUNDENPROJAHR];
			dDiv	*= aValues[VAR_LAMPENZAHL];

			if(dDiv<0.000000001)dDiv=0.000000001;

			dVal	 = aValues[VAR_BETRIEBSKOSTEN];
			dVal	/= dDiv;
			dVal	-= aValues[VAR_LEISTUNG]*aValues[VAR_STROMPREIS]/1000.0;

			if(dVal<0.000000001)dVal=0.000000001;

			aValues[VAR_LEBENSDAUER] = aValues[VAR_LAMPENPREIS]/dVal;

			if(aValues[VAR_LEBENSDAUER]<0.0)aValues[VAR_LEBENSDAUER]=0.0;

			break;
		}


}

